#
# BEFORE UPDATING THIS PACKAGE, YOU _MUST_ DO THE FOLLOWING:
# - DO A LOCAL BUILD
# - INSTALL IT IN A TEST MACHINE
# - CHECK THAT 'display_help http://google.com' STILL WORK (INCLUDING CLOSING IT)
# - CHECK THAT MCC STILL RUNS
#

# lib is called libwebkitgtk-%{libver}.so.%{major}
%define libver  1.0 
%define major	0
%define oname		webkit
%define libname		%mklibname webkitgtk %{libver} %{major}
%define develname	%mklibname webkitgtk %{libver} -d
%define inspectorname	webkit%{libver}-webinspector
%define libgirname      %mklibname %name-gir %{libver}
%define libgitjscore    %mklibname jscore-gir %{libver}
%define libjavascriptcoregtk    %mklibname javascriptcoregtk %{libver} %{major}

%define lib3ver  3.0
%define major3   0
%define lib3name	%mklibname webkitgtk %{lib3ver} %{major3}
%define develname3	%mklibname webkitgtk %{lib3ver} -d
%define inspector3name	webkit%{lib3ver}-webinspector
%define libjavascriptcoregtk3    %mklibname javascriptcoregtk %{lib3ver} %{major3}
%define libgirname3	%mklibname %name-gir %{lib3ver}
%define libgitjscore3	%mklibname jscore-gir %{lib3ver}

%define pango	0
%if %pango
%define fontreq		pango-devel
%define fontback	pango
%else
%define fontreq		fontconfig-devel >= 1.0.0
%define fontback	freetype
%endif

Summary:	Web browser engine
Epoch:		1
Name:		webkit
Version:	1.8.3
Release:	%mkrel 1
License:	BSD and LGPLv2+
Group:		System/Libraries
Source0:	http://webkitgtk.org/releases/%{oname}-%{version}.tar.xz
Patch0:		webkit-1.7.90-link.patch
# (blino) needed for first-time wizard (display_help) to be able to close its window with javascript
Patch2:		webkit-1.6.1-allowScriptsToCloseWindows.patch
Patch3:		webkit-1.7.90-fix-documentation-build.patch
URL:		http://www.webkitgtk.org
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	curl-devel >= 7.11.0
BuildRequires:	flex
BuildRequires:	%{fontreq}
BuildRequires:	gperf
BuildRequires:	libicu-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	librsvg-devel >= 2.2.0
BuildRequires:	libstdc++-devel
BuildRequires:	libsoup-devel >= 2.29.90
BuildRequires:	libtool
BuildRequires:	libxslt-devel
BuildRequires:	libxt-devel
BuildRequires:	pkgconfig
BuildRequires:	gtk+2-devel
BuildRequires:	gtk+3-devel
BuildRequires:	libgail-3.0-devel
BuildRequires:	sqlite3-devel
BuildRequires:	xft2-devel
BuildRequires:	libgstreamer-plugins-base-devel
BuildRequires:	libgnome-keyring-devel
BuildRequires:	gobject-introspection-devel
BuildRequires:	enchant-devel
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(geoclue)
BuildRequires:	gail-devel
BuildRequires:  perl-Switch
Requires:	%{libname}

%description
WebKit is an open source web browser engine.

%package -n %{name}%{libver}
Summary:        GTK+ port of WebKit web browser engine - shared files
Group:          Development/GNOME and GTK+
Requires:	%{libname} = %{epoch}:%{version}

%description -n %{name}%{libver}
WebKit is an open source web browser engine.
This package contains the shared files used by %{name}%{libver}

%package -n %{libname}
Summary:	GTK+ port of WebKit web browser engine
Group:		System/Libraries
Requires:	%{name} = %{epoch}:%{version}
Requires:	%{name}%{libver} = %{epoch}:%{version}
Obsoletes:	%{mklibname WebKitGdk 0} <= 0-0.30465
Obsoletes:	%{mklibname WebKitGtk 1} <= 0-0.32877
Obsoletes:	%{mklibname webkitgtk 1} <= 1.1.1-3mdv
Obsoletes:	%{mklibname webkitgtk 2} <= 1.1.1-3mdv
Obsoletes:      %{mklibname webkitgtk-1.00} <= 1.3.12-3.mga1
# (fhimpe) This provides should probably be removed when major changes
Provides:	%{mklibname webkitgtk 2} = %{version}-%{release}
Provides:	libwebkitgtk = %{version}-%{release}
# Needed for Web Inspector feature to work
Suggests:	%{inspectorname} = %{epoch}:%{version}
Conflicts:	gir-repository < 0.6.5-7mdv2010.1

%description -n %{libname}
The GTK+ port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+ UI toolkit on platforms like
Linux.

%package -n %{libjavascriptcoregtk}
Summary:        GTK+ port of WebKit web browser engine
Group:          System/Libraries
Requires:       %{libname} = %{epoch}:%{version}
Obsoletes:	%{_lib}javascriptcoregtk1.0 < %{epoch}:%{version}-%{release}

%description -n %{libjavascriptcoregtk}
The GTK+ port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+ UI toolkit on platforms like
Linux.

%package -n %{develname}
Summary:	Development files for WebKit GTK+ port
Group:		Development/GNOME and GTK+
Provides:	webkitgtk-devel = %{version}-%{release}
Provides:	libwebkitgtk-devel = %{version}-%{release}
Provides:	%{mklibname webkitgtk -d} = %{version}-%{release}
Requires:	%{libname} = %{epoch}:%{version}-%{release}
Requires:	%{libjavascriptcoregtk} = %{epoch}:%{version}-%{release}
Requires:	%{libgitjscore} = %epoch:%{version}-%{release}
Requires:	%{libgirname} = %epoch:%{version}-%{release}
Obsoletes:	%{mklibname WebKitGtk -d} <= 0-0.32877
Obsoletes:	%{mklibname webkitgtk -d} < 1.1.1-2mdv
Conflicts:	gir-repository < 0.6.5-7mdv2010.1

%description -n %{develname}
The GTK+ port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+ UI toolkit on platforms like
Linux. This package contains development headers.

%package gtklauncher
Summary:	WebKit GTK+ example application
Group:		Development/GNOME and GTK+
Conflicts:	%{mklibname WebKitGtk 0} <= 0-0.30465

%description gtklauncher
GtkLauncher is an example application for WebKit GTK+.

%package jsc
Summary:	JavaScriptCore shell for WebKit GTK+
Group:		Development/GNOME and GTK+

%description jsc
jsc is a shell for JavaScriptCore, WebKit's JavaScript engine. It
allows you to interact with the JavaScript engine directly.

%package -n %{inspectorname}
Summary:	Data files for WebKit GTK+'s Web Inspector
Group:		System/Libraries
Provides:	webkit-webinspector = %{version}-%{release}
Obsoletes:	webkit-webinspector < 1.1.1-2mdv

%description -n %{inspectorname}
WebKit GTK+ has a feature called the Web Inspector, which allows
detailed analysis of any given page's page source, live DOM hierarchy
and resources. This package contains the data files necessary for Web
Inspector to work.

%package -n %{name}3
Summary:        Web browser engine
Group:          System/Libraries
Requires:       %{lib3name} = %{epoch}:%{version}

%description -n %{name}3
WebKit is an open source web browser engine.

%package -n %{name}%{lib3ver}
Summary:        GTK+3 port of WebKit web browser engine - shared files
Group:          Development/GNOME and GTK+
Requires:       %{lib3name} = %{epoch}:%{version}

%description -n %{name}%{lib3ver}
WebKit is an open source web browser engine.
This package contains the shared files used by %{name}%{lib3ver}

%package -n %{lib3name}
Summary:        GTK+3 port of WebKit web browser engine
Group:          System/Libraries
Requires:       %{name}3 = %{epoch}:%{version}
Requires:       %{name}%{lib3ver} = %{epoch}:%{version}
Provides:       libwebkitgtk3 = %{version}-%{release}
# Needed for Web Inspector feature to work
Suggests:       %{inspector3name} = %{epoch}:%{version}

%description -n %{lib3name}
The GTK+3 port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+3 UI toolkit on platforms like
Linux.

%package -n %{libjavascriptcoregtk3}
Summary:        GTK+3 port of WebKit web browser engine
Group:          System/Libraries
Requires:       %{lib3name} = %{epoch}:%{version}
Obsoletes:	%{_lib}javascriptcoregtk3.0 < %{epoch}:%{version}-%{release}

%description -n %{libjavascriptcoregtk3}
The GTK+3 port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+3 UI toolkit on platforms like
Linux.

%package -n %{develname3}
Summary:        Development files for WebKit GTK+3 port
Group:          Development/GNOME and GTK+
Provides:       webkitgtk3-devel = %{version}-%{release}
Provides:       libwebkitgtk3-devel = %{version}-%{release}
Requires:       %{lib3name} = %{epoch}:%{version}-%{release}
Requires:	%{libjavascriptcoregtk3} = %{epoch}:%{version}-%{release}
Requires:	%{libgitjscore3} = %{epoch}:%{version}-%{release}
Requires:	%{libgirname3} = %{epoch}:%{version}-%{release}

%description -n %{develname3}
The GTK+ port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+ UI toolkit on platforms like
Linux. This package contains development headers.

%package -n webkit3-gtklauncher
Summary:        WebKit GTK+3 example application
Group:          Development/GNOME and GTK+

%description -n webkit3-gtklauncher
GtkLauncher is an example application for WebKit GTK+3.

%package -n webkit3-jsc
Summary:        JavaScriptCore shell for WebKit GTK+3
Group:          Development/GNOME and GTK+

%description -n webkit3-jsc
jsc is a shell for JavaScriptCore, WebKit's JavaScript engine. It
allows you to interact with the JavaScript engine directly.

%package -n %{inspector3name}
Summary:        Data files for WebKit GTK+'s Web Inspector
Group:          System/Libraries
Provides:       webkit3-webinspector = %{version}-%{release}

%description -n %{inspector3name}
WebKit GTK+3 has a feature called the Web Inspector, which allows
detailed analysis of any given page's page source, live DOM hierarchy
and resources. This package contains the data files necessary for Web
Inspector to work.

%package -n %{libgitjscore}
Summary:        GObject Introspection interface description for JSCore
Group:          System/Libraries
Requires:       %{libjavascriptcoregtk} = %epoch:%{version}-%{release}
Conflicts:	%{_lib}webkitgtk1.0_2 < %epoch:%{version}-%{release}

%description -n %{libgitjscore}
GObject Introspection interface description for JSCore.

%package -n %{libgirname}
Summary:        GObject Introspection interface description for %name
Group:          System/Libraries
Requires:       %{libname} = %epoch:%{version}-%{release}
Conflicts:	%{_lib}webkitgtk1.0_2 < %epoch:%{version}-%{release}

%description -n %{libgirname}
GObject Introspection interface description for WebKit.

%package -n %{libgitjscore3}
Summary:        GObject Introspection interface description for JSCore
Group:          System/Libraries
Requires:       %{libjavascriptcoregtk3} = %epoch:%{version}-%{release}
Conflicts:	%{libjavascriptcoregtk3} < %epoch:1.5.2-2

%description -n %{libgitjscore3}
GObject Introspection interface description for JSCore.

%package -n %{libgirname3}
Summary:        GObject Introspection interface description for %name
Group:          System/Libraries
Requires:       %{lib3name} = %epoch:%{version}-%{release}
Conflicts:	%{lib3name} < %epoch:1.5.2-2

%description -n %{libgirname3}
GObject Introspection interface description for WebKit.

%prep
%setup -q
%patch0 -p0 -b .link
%patch2 -p1 -b .allowScriptsToCloseWindows
%patch3 -p1 -b .dir

%build
mkdir -p gtk2
pushd gtk2
CONFIGURE_TOP=.. %configure2_5x	--with-gtk=2.0 \
	--with-font-backend=%{fontback} \
	--enable-video --enable-introspection
make
popd

mkdir -p gtk3
pushd gtk3
CONFIGURE_TOP=.. %configure2_5x  --with-gtk=3.0 \
	--with-font-backend=%{fontback} \
	--enable-video --enable-introspection
make
popd

%install
rm -rf %{buildroot}
%makeinstall_std -C gtk2
%makeinstall_std -C gtk3
mkdir -p %{buildroot}%{_libdir}/%{name}
install -m 755 gtk2/Programs/GtkLauncher %{buildroot}%{_libdir}/%{name}

mkdir -p %{buildroot}%{_libdir}/%{name}3
install -m 755 gtk3/Programs/GtkLauncher %{buildroot}%{_libdir}/%{name}3

# only useful for testing, should not be installed system-wide.
# reported upstream as 22812 - AdamW 2008/12
rm -rf %{buildroot}%{_libdir}/libtestnetscapeplugin.*

#we don't want these
find %{buildroot} -name '*.la' -exec rm -f {} ';'

%find_lang %{name}-2.0

%find_lang %{name}-3.0

%files -f %{name}-2.0.lang

%files -n %{name}%{libver}
%defattr(0755,root,root)
%dir %{_datadir}/webkitgtk-1.0
%{_datadir}/webkitgtk-1.0/images
%{_datadir}/webkitgtk-1.0/resources

%files -n %{develname}
%defattr(644,root,root,755)
%{_libdir}/lib%{name}gtk-%{libver}.so
%{_libdir}/libjavascriptcoregtk-%{libver}.so
%{_includedir}/%{name}gtk-%{libver}
%{_libdir}/pkgconfig/%{name}-%{libver}.pc
%{_libdir}/pkgconfig/javascriptcoregtk-%{libver}.pc
%_datadir/gir-1.0/JSCore-%{libver}.gir
%_datadir/gir-1.0/WebKit-%{libver}.gir

%files -n %{libname}
%defattr(644,root,root,755)
%{_libdir}/lib%{name}gtk-%{libver}.so.%{major}*

%files -n %{libjavascriptcoregtk}
%defattr(644,root,root,755)
%{_libdir}/libjavascriptcoregtk-%{libver}.so.%{major}*

%files -n %{libgitjscore}
%defattr(644,root,root,755)
%_libdir/girepository-1.0/JSCore-%{libver}.typelib

%files -n %{libgirname}
%defattr(644,root,root,755)
%_libdir/girepository-1.0/WebKit-%{libver}.typelib

%files gtklauncher
%defattr(0755,root,root)
%{_libdir}/%{name}/GtkLauncher

%files jsc
%defattr(0755,root,root)
%{_bindir}/jsc-1

%files -n %{inspectorname}
%defattr(0755,root,root)
%{_datadir}/%{name}gtk-%{libver}/webinspector

%files -n %{name}3 -f %{name}-3.0.lang
%defattr(0755,root,root)

%files -n %{name}%{lib3ver}
%defattr(0755,root,root)
%dir %{_datadir}/webkitgtk-3.0
%{_datadir}/webkitgtk-3.0/images
%{_datadir}/webkitgtk-3.0/resources

%files -n %{develname3}
%defattr(644,root,root,755)
%{_libdir}/lib%{name}gtk-%{lib3ver}.so
%{_libdir}/libjavascriptcoregtk-%{lib3ver}.so
%{_includedir}/%{name}gtk-%{lib3ver}
%{_libdir}/pkgconfig/%{name}gtk-%{lib3ver}.pc
%{_libdir}/pkgconfig/javascriptcoregtk-%{lib3ver}.pc
%_datadir/gir-1.0/JSCore-%{lib3ver}.gir
%_datadir/gir-1.0/WebKit-%{lib3ver}.gir

%files -n %{lib3name}
%defattr(644,root,root,755)
%{_libdir}/lib%{name}gtk-%{lib3ver}.so.%{major3}*

%files -n %{libjavascriptcoregtk3}
%defattr(644,root,root,755)
%{_libdir}/libjavascriptcoregtk-%{lib3ver}.so.%{major}*

%files -n %{name}3-gtklauncher
%defattr(0755,root,root)
%{_libdir}/%{name}3/GtkLauncher

%files -n %{name}3-jsc
%defattr(0755,root,root)
%{_bindir}/jsc-3

%files -n %{inspector3name}
%defattr(0755,root,root)
%{_datadir}/%{name}gtk-%{lib3ver}/webinspector

%files -n %{libgitjscore3}
%defattr(-,root,root)
%_libdir/girepository-1.0/JSCore-%{lib3ver}.typelib

%files -n %{libgirname3}
%defattr(-,root,root)
%_libdir/girepository-1.0/WebKit-%{lib3ver}.typelib


%changelog

* Fri Oct 26 2012 luigiwalser <luigiwalser> 1:1.8.3-1.mga2
+ Revision: 310289
- 1.8.3 (fixes several security issues)

  + ovitters <ovitters>
    - new version 1.8.2
    - new version 1.8.1

* Sat Apr 07 2012 fwang <fwang> 1:1.8.0-2.mga2
+ Revision: 229532
- fix mklibname usage

* Sat Apr 07 2012 fwang <fwang> 1:1.8.0-1.mga2
+ Revision: 229490
- new version 1.8.0

* Thu Mar 22 2012 ovitters <ovitters> 1:1.7.92-1.mga2
+ Revision: 225610
- update file list
- new version 1.7.92
- drop merged patch

  + luigiwalser <luigiwalser>
    - add patch 1 from debian to fix build issue

  + fwang <fwang>
    - more linkage fix
    - try to fix build
    - fix build dir
    - br gecolue
    - new version 1.7.90

* Mon Feb 20 2012 luigiwalser <luigiwalser> 1:1.7.5-1.mga2
+ Revision: 211106
- add patches from Debian to fix build issues
- 1.7.5

* Tue Feb 07 2012 tv <tv> 1:1.7.4-2.mga2
+ Revision: 205854
- fix obsoltes (#3262

* Tue Jan 17 2012 fwang <fwang> 1:1.7.4-1.mga2
+ Revision: 197476
- update file list
- rediff link patch
- br gl
- new version 1.7.4

* Sat Oct 01 2011 blino <blino> 1:1.6.1-2.mga2
+ Revision: 150603
- rediff and simplify allowScriptsToCloseWindows patch

* Tue Sep 27 2011 fwang <fwang> 1:1.6.1-1.mga2
+ Revision: 149464
- new version 1.6.1

* Sat Sep 17 2011 wally <wally> 1:1.5.2-4.mga2
+ Revision: 144414
- get rid of .la files

* Sun Sep 11 2011 fwang <fwang> 1:1.5.2-3.mga2
+ Revision: 142265
- rebuild for new libpng
- really split typelib
- New version 1.5.2
- temporary disable closewindow patch, huge rediff required
- update requirement
- rename jscore libpackage

* Thu Jul 07 2011 fwang <fwang> 1:1.5.1-2.mga2
+ Revision: 119566
- rebuild for typelib rpm provides

* Sun Jul 03 2011 dmorgan <dmorgan> 1:1.5.1-1.mga2
+ Revision: 117803
- Fix typo in file lists
- Fix file lists
- Remove %%clean section
- Remove .la files
- Fix list
- Fix list

  + fwang <fwang>
    - new version 1.5.1

* Fri Jul 01 2011 dmorgan <dmorgan> 1:1.4.2-2.mga2
+ Revision: 117156
- Add obsoletes to ease update

* Fri Jul 01 2011 fwang <fwang> 1:1.4.2-1.mga2
+ Revision: 117155
- rediff linkage patch
- new version 1.4.2

* Fri Jun 24 2011 dmorgan <dmorgan> 1:1.4.1-5.mga2
+ Revision: 113170
- Fix requires by adding %%epoch

* Mon Jun 20 2011 dmorgan <dmorgan> 1:1.4.1-4.mga2
+ Revision: 110421
- Fix typo
- Add back %%defattr
- Remove buildroot
  Add perl-Switch as buildrequire
- Commit patches
- New version 1.4.1
  Merge with webkit3 package
  Create subpackages for gir files

* Sun Apr 10 2011 dmorgan <dmorgan> 1:1.2.7-4.mga1
+ Revision: 82697
- New version 1.2.7

  + ennael <ennael>
    - bump release for rebuild

* Sun Jan 16 2011 pterjan <pterjan> 1:1.2.5-3.mga1
+ Revision: 20442
- Drop a lot of tests on old versions

  + kharec <kharec>
    - imported package webkit

